package com.dx.union;


import cn.hutool.core.annotation.Alias;
import cn.hutool.core.date.DateTime;
import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.StrUtil;

import java.util.Objects;

public class User {
    @Alias("用户名")
    private String username;
    @Alias("密码")
    private String password;
    @Alias("上班卡")
    private String isStartWorkSign;
    @Alias("下班卡")
    private String isEndWorkSign;

    public String getUsername() {
        return username;
    }

    public void setUsername(String username) {
        this.username = username;
    }

    public String getPassword() {
        return password;
    }

    public void setPassword(String password) {
        this.password = password;
    }

    public String getIsStartWorkSign() {
        return isStartWorkSign;
    }

    public void setIsStartWorkSign(String isStartWorkSign) {
        this.isStartWorkSign = isStartWorkSign;
    }

    public String getIsEndWorkSign() {
        return isEndWorkSign;
    }

    public void setIsEndWorkSign(String isEndWorkSign) {
        this.isEndWorkSign = isEndWorkSign;
    }

    public boolean isTodaySign(int signMark) {
        if (signMark == 0) {
            // 校验上班的打卡逻辑
            if (StrUtil.isEmpty(this.getIsStartWorkSign())) {
                return false;
            }
            DateTime dateTime = DateUtil.parse(this.getIsStartWorkSign(), "yyyy-MM-dd");
            return DateUtil.isSameDay(dateTime, DateUtil.date());
        } else if (signMark == 1) {
            if (StrUtil.isEmpty(this.getIsEndWorkSign())) {
                return false;
            }
            DateTime dateTime = DateUtil.parse(this.getIsEndWorkSign(), "yyyy-MM-dd");
            return DateUtil.isSameDay(dateTime, DateUtil.date());
        }
        return false;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        User user = (User) o;
        return Objects.equals(username, user.username) && Objects.equals(password, user.password) ;
    }

    @Override
    public int hashCode() {
        return Objects.hash(username, password);
    }

    @Override
    public String toString() {
        return "User{" +
                "username='" + username + '\'' +
                ", password='" + password + '\'' +
                ", isStartWorkSign='" + isStartWorkSign + '\'' +
                ", isEndWorkSign='" + isEndWorkSign + '\'' +
                '}';
    }
}
